var wgdb = require("./");

var db = new wgdb(1000, 2000000);

function del(error){
    console.dir(error);
    db.detach(function(){
        db.delete();
    });
}

function add_record(key, value, done){
    db.createRecord(2, function(error, record){
        if(error) return del(error);

        record.setField(0, key, function(error){
            if(error) return del(error);

            record.setField(1, value, function(error){
                if(error) return del(error);

                done();
            });
        });
    });
}

function setup(done){
    add_record("key1", 10, function(){
        add_record("key2", 15, function(){
            add_record("key3", 20, function(){
                done();
            });
        });
    });
};

function find(last, done){
    db.findRecord(1, wgdb.GTEQUAL, 5, last, function(error, record){
        if(error) return del(error);
        if(!record) return del("no record found");

        record.getFields(function(error, fields){
            if(error) return del(error);

            console.dir(fields);

            done(record);
        });
    });
}

db.attach(function(error){
    if(error) return del(error);

    setup(function(){
        db.query([
            [1, wgdb.GTEQUAL, 5]
        ], function(error, cursor){
            if(error) return del(error);
            if(!cursor) return del("no cursor created");

            cursor.next(function(error, record){
                if(error) return del(error);
                if(!record) return del("no more records");

                record.getFields(function(error, fields){
                    if(error) return del(error);
                    console.dir(fields);

                    cursor.next(function(error, record){
                        if(error) return del(error);
                        if(!record) return del("no more records");

                        record.getFields(function(error, fields){
                            if(error) return del(error);

                            console.dir(fields);

                            cursor.next(function(error, record){
                                if(error) return del(error);
                                if(!record) return del("no more records");

                                record.getFields(function(error, fields){
                                    if(error) return del(error);

                                    console.dir(fields);

                                    cursor.next(function(error, record){
                                        if(error) return del(error);
                                        if(!record) return del("no more records");

                                        record.getFields(function(error, fields){
                                            if(error) return del(error);

                                            console.dir(fields);

                                            return del();
                                        });
                                    });
                                });
                            });
                        });
                    });
                });
            });
        });
    });
});
